#ifndef WIME_CANNAAPI_H
#define WIME_CANNAAPI_H

#define CANNA_NEW_WCHAR_AWARE
#ifdef __WINNT__
  #include <windows.h>
#else
  typedef void* HWND;
  typedef void* HIMC;
#endif
#include <stdint.h>
#include <canna/RK.h>
#include "libwime.h"
#include "lib.h"

#define WIME_CANNA_MAJOR 3
#define WIME_CANNA_MINOR 6
#define RETURN_VERSION_ERROR_STAT -2

typedef struct{
    uint8_t Major;
    uint8_t Minor;
    uint16_t Length;
    Array Data;
} __attribute__((packed)) CannaHeader ;
#define CANNAHEADERSIZE 4

typedef struct{
    HWND Win;
    int Conv;		//Ѵʸֹ롣ʳξ֤λ-1
    int FerMode;	//RkBgnBunΥ⡼
    RkStat RkSt;	//!!! äƤɬפʤ
    Array CandInfo;	//ʸѴꥹȤΥڡ
    int Connection;	//̿Υեǥץ
    unsigned SerialNum; //ֹ̤档 memo'libcannaȤʻ'򻲾

    Array Dics;		//̾Υꥹ(char*)
    Array DicMode;	//Υ⡼(int32)

    int FixedNum; //ưѴ⡼ɤǾ˳ꤵ줿ʸο
    Array FixedStr; //˳ꤵ줿ʸηʸΥꥹ(int16_t,le)
    Array FixedYomi; //ʸɤ߲̾Υꥹ(int16_t,le)
} CannaContext_t;

//CandInfo
#define CANDLISTMAX 4
typedef struct{
    int Size[CANDLISTMAX];	//ƥڡθ
    int Seq;			//䥦ɥФʤȤθ
} CandListPageInfo;

typedef struct{
    int Connection; //̿Υեǥץ
    char *User;
    char *App;
    char *Group;
} ClientData_t;
    
//ʻ쥳
typedef struct{
    char *Ccode;	//ʤΥɡƬ'#'ϤĤʤɽ
    int Wcode;		//STYLEBUF.dwStyle
} HinshiCor;

//եΥǡ
struct GlobalData_t{
    HinshiCor* HinshiTab;
};

extern PROT_RD FuncRead;
extern PROT_WR FuncWrite;

typedef bool (*WMCANNAPROTO)(CannaHeader*,int);

bool wm_canna_init(CannaHeader *ch,int fd);
bool wm_dup_context(CannaHeader *ch,int fd);
bool wm_mount_dic(CannaHeader *ch,int fd);
bool wm_begin_conv(CannaHeader *ch,int fd);
bool wm_create_context(CannaHeader *ch,int fd);
bool wm_get_candi_list(CannaHeader *ch,int fd);
bool wm_set_app_name(CannaHeader *ch,int fd);
bool wm_notice_group(CannaHeader *ch,int fd);
bool wm_get_status(CannaHeader *ch,int fd);
bool wm_end_conv(CannaHeader *ch,int fd);
bool wm_unmount_dic(CannaHeader *ch,int fd);
bool wm_canna_finalize(CannaHeader *ch,int fd);
bool wm_close_context(CannaHeader *ch,int fd);
bool wm_get_dic_list(CannaHeader *ch,int fd);
bool wm_resize_pause(CannaHeader *ch,int fd);
bool wm_define_word(CannaHeader *ch,int fd);
bool wm_get_dir_list(CannaHeader *ch,int fd);
bool wm_remount_dic(CannaHeader *ch,int fd);
bool wm_mount_dic_list(CannaHeader *ch,int fd);
bool wm_query_dic(CannaHeader *ch,int fd);
bool wm_delete_word(CannaHeader *ch,int fd);
bool wm_get_yomi(CannaHeader *ch,int fd);
bool wm_subst_yomi(CannaHeader *ch,int fd);
bool wm_store_yomi(CannaHeader *ch,int fd);
bool wm_store_range(CannaHeader *ch,int fd);
bool wm_get_last_yomi(CannaHeader *ch,int fd);
bool wm_flush_yomi(CannaHeader *ch,int fd);
bool wm_remove_yomi(CannaHeader *ch,int fd);
bool wm_get_simple_kanji(CannaHeader *ch,int fd);
bool wm_get_hinshi(CannaHeader *ch,int fd);
bool wm_get_lex(CannaHeader *ch,int fd);
bool wm_set_locale(CannaHeader *ch,int fd);
bool wm_auto_conv(CannaHeader *ch,int fd);
bool wm_query_ext(CannaHeader *ch,int fd);
bool wm_kill_server(CannaHeader *ch,int fd);

bool wm_get_server_info(CannaHeader *ch,int fd);
bool wm_get_acl(CannaHeader *ch,int fd);
bool wm_create_dic(CannaHeader *ch,int fd);
bool wm_delete_dic(CannaHeader *ch,int fd);
bool wm_rename_dic(CannaHeader *ch,int fd);
bool wm_get_word_text_dic(CannaHeader *ch,int fd);
bool wm_list_dic(CannaHeader *ch,int fd);
bool wm_sync(CannaHeader *ch,int fd);
bool wm_chmod_dic(CannaHeader *ch,int fd);
bool wm_copy_dic(CannaHeader *ch,int fd);

bool wm_wime_dialog(CannaHeader* ch,int fd);
bool wm_wime_list_context(CannaHeader* ch,int fd);
bool wm_wime_send_char(CannaHeader* ch,int fd);

#endif
