#include <limits.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ut.h"
#include "lib.h"

uint16_t* Swap2p(void *x,int dist)
{
    unsigned char *a,*b,c;
    a = (unsigned char*)x;
    b = a+dist;
    c = *a; *a = *b; *b = c;
    return (uint16_t*)x;
}

uint16_t Swap2(uint16_t x)
{
    return *Swap2p(&x,1);
}

uint16_t Swap2c(const void *x)
{
    return Swap2(*(const uint16_t*)x);
}

uint32_t Swap4(uint32_t x)
{
    Swap2p(&x,3);
    Swap2p(((char*)&x)+1,1);
    return x;
}

uint32_t Swap4c(const void *x)
{
    return Swap4(*(const uint32_t*)x);
}

unsigned char* rev_copy(unsigned char* to,const unsigned char* from,int len)
{
    unsigned char* r = to;
    from += len;
    while(--len >= 0)
	*(to++) = *(--from);
    return r;
}

int* RevInt(int* x)
{
    int x0 = *x;
    return (int*)rev_copy((unsigned char*)x,(const unsigned char*)&x0,sizeof(int));
}

/*
  wchar_t礭gccwinegccǰ㤦
  ̤Υǥ쥯ȥgccȤǽ⤢Τǡ𤷤ʤ褦wchar_t,wcs...()
  Ȥ鷺˼δؿ뤳Ȥˤ롣
*/
int WcLen(const uint16_t* s)
{
    const uint16_t* s0 = s;
    while(*(s++) != 0)
	;
    return s-s0-1;
}
uint16_t* WcChr(uint16_t* s,uint16_t c)
{
    while(*s!=0 && *s!=c)
	++s;
    return (*s!=0 || c==0) ? s : NULL;
}
uint16_t* WcCpy(uint16_t* dst,const uint16_t* src)
{
    return memcpy(dst,src,(WcLen(src)+1)*2);
}

//ʸꥹȤn(>=0)ܤǤ֤
uint16_t* StrListNthWc(uint16_t* s,int nmax,int n)
{
    int x;
    for(x=0; x<n && x<nmax && *s!=0; ++x){
	s += WcLen(s)+1; //̥ʸμ
    }
    return (x<nmax && *s!=0) ? s : NULL;
}

/*
  eucjpwcharʸcharʸˤ롣
  srcΣХʸϥȥ륨ǥȾѥʤ0x8eĤƤʤ
  dst==NULLΤȤmallocǳݤ
*/
char *ToMb(char *dst,const uint16_t *src)
{
    char *dst0;
    unsigned char uc;

    if(dst == NULL)
	dst = malloc(WcLen(src)*2+1);
    dst0 = dst;
    for(; *src!=0; ++src){
	if((*src & 0xff) != 0){
	    *(uint16_t*)dst = *src;
	    dst += 2;
	}else{
	    uc = (char)(*src>>8);
	    if(uc>=0xa1 && uc<=0xdf) //Ⱦѥ
		*(dst++) = 0x8e;
	    *(dst++) = uc;
	}
    }
    *dst = 0;
    return dst0;
}

/*
  eucjpcharʸwcharʸˤ롣
  destΣХʸϥȥ륨ǥȾѥʤ0x8eĤƤʤ
  destʸ֤
*/
int ToWcLe(uint16_t* dest,const char* src)
{
    uint16_t *dest0 = dest;
    uint16_t wc;
    while(*src != 0){
	if((*src & 0x80)!=0){
	    if((unsigned char)*src == 0x8e)
		wc = ((uint16_t)*(src+1))<<8; //Ⱦѥ
	    else
		wc = *(uint16_t*)src;
	    src += 2;
	}else //ascii
	    wc = ((uint16_t)*(src++))<<8;
	*(dest++) = wc;
    }
    *dest = 0;
    return dest-dest0;
}

void Dump1(char *fmt,void *adr,int num,int cr)
{
    uint8_t *p = (uint8_t *)adr;
    while(--num >= 0)
	printf(fmt,*(p++));
    if(cr)
	printf("\n");
}
void Dump2(char *fmt,void *adr,int num,int cr)
{
    uint16_t *p = (uint16_t*)adr;
    while(--num >= 0)
	printf(fmt,*(p++));
    if(cr)
	printf("\n");
}
void Dump2le(char *fmt,void *adr,int num,int cr)
{
    uint16_t *p = (uint16_t*)adr;
    for(; --num >= 0; ++p)
	printf(fmt,((*p>>8)|(*p<<8))&0xffff);
    if(cr)
	printf("\n");
}
void Dump4(char *fmt,void *adr,int num,int cr)
{
    uint32_t *p = (uint32_t*)adr;
    while(--num >= 0)
	printf(fmt,*(p++));
    if(cr)
	printf("\n");
}

//ꥹȽλΥ̥ʸΰ֤֤
uint16_t* DumpList2(uint16_t *ws,int nl)
{
    int moji;
    Array buf;
    ArNew(&buf,1,NULL);
    while(*ws != 0){
	moji = WcLen(ws)+1;
	ArAlloc(&buf,moji*2);
	printf("[%s]",ToMb(buf.adr,ws));
	ws += moji;
    }
    if(nl)
	printf("\n");
    ArDelete(&buf);
    return ws;
}

/*
  ɤʸ޻ˤ
*/
char* Zen2Roman(char* dest,const char* ej0)
{
    static const char* tab[]={
	"xa","a","xi","i","xu","u","xe","e","xo","o",
	"ka","ga","ki","gi","ku","gu","ke","ge","ko","go",
	"sa","za","si","zi","su","zu","se","ze","so","zo",
	"ta","da","ti","di","xtu","tu","du","te","de","to","do",
	"na","ni","nu","ne","no",
	"ha","ba","pa","hi","bi","pi","hu","bu","pu","he","be","pe","ho","bo","po",
	"ma","mi","mu","me","mo",
	"xya","ya","xyu","yu","xyo","yo",
	"ra","ri","ru","re","ro",
	"xwa","wa","wi","we","wo","nn"
    };
    static const char sym[]={ /* 0xa1xx */
	' ', 	',', 	'.', 	',', 	'.',	0,	':',	//a1
	';',	'?',	'!',	0,	0,	0,	'`',	0,	//a8
	'^',	'~',	'_',	0,	0,	0,	0,	0,	//b0
	0,	0,	0, 	0,	'-',	0,	0,	'/',	//b8
	'\\',	'-',	0,	'|',	0,	0,	0,	0,	//c0
	0,	0,	'(',	')',	0,	0,	'[',	']',	//c8
	'{',	'}',	'<',	'>',	0,	0,	'[',	']',	//d0
	0,	0,	0,	0,	'+',	'-',	0,	'*',	//d8
	'/',	'=',	0,	'<',	'>',	0,	0,	0,	//e0
	0,	0,	0,	0,	0,	0,	0,	'\\',	//e8
	'$',	0,	0,	'%',	'#',	'&',	'*',	'@'	//f0
    };
    const char* s;
    char* dest0=dest;
    unsigned char *ej=(unsigned char*)ej0;
    while(*ej != 0){
	if((*ej & 0x80) == 0){
	    //ascii
	    *(dest++) = *(ej++);
	}else{
	    switch(*(ej++)){
	    case 0xa1: //
		if(*ej>=0xa1 && *ej<=0xf7)
		    *(dest++) = sym[*ej-0xa1];
		++ej;
		break;
	    case 0xa3: //ե٥å
		*(dest++) = *(ej++)-0xb0+0x30;
		break;
	    case 0xa4:
		s = tab[*(ej++)-0xa1];
		strcpy(dest,s);
		dest += strlen(s);
	    }
	}
    }
    *dest = 0;
    return dest0;
}

/*
  sjisȾѥʸѤҤ餬ʸľ
  srcΥ̥ʸlenʸ(Ⱦѥʤǿ)ޤǡ
  dstκǸ˥̥ʸɲä롣
  ͡ѤȾѥʸ
  dstsrcƱǤokssz==1ΤȤϤޤȤưʤ
 */
int SjStrHan2Zen(char *dst,char *src,int ssz,unsigned char opt,int syn,int len)
{
    int n;
    char *src0=src;
    while(len>0 && *src!=0){
	n = SjHan2Zen(dst,src,ssz,opt,syn);
	len -= n;
	src += n*ssz;
	dst += 2;
    }
    *dst = 0;
    return (src-src0)/ssz;
}

/*
  sjisȾѥʤѤҤ餬ʤľ
  ssz=srcΣʸΥХȿ
  opt=src˲û
  syn=
  ͡ȾѤǻȤäʸιǣʸȤȤ⤢
  dstsrcƱǤokssz==1ΤȤϼΥХȤ񤭤

  ??? 󤤤ˤʤäƤ򤭤äʬ褦
*/
int SjHan2Zen(char *dst,char *src,int ssz,unsigned char opt,int syn)
{
    static uint16_t as20_2f[]={
	0x8140/* */,	0x8149/*!*/,	0x8168/*"*/,	0x8194/*#*/,
	0x8190/*$*/,	0x8193/*%*/,	0x8195/*&*/,	0x8166/*'*/,
	0x8169/*(*/,	0x816a/*)*/,	0x8196/***/,	0x817b/*+*/,
	0x8143/*,*/,	0x817c/*-*/,	0x8144/*.*/,	0x815e/*/*/
    };
    static uint16_t as3a_40[]={
	0x8146/*:*/,	0x8147/*;*/,	0x8183/*<*/,	0x8181/*=*/,
	0x8184/*>*/,	0x8148/*?*/,	0x8197/*@*/
    };
    static uint16_t as5b_60[]={
	0x816d/*[*/,	0x815f/*bs*/,	0x816e/*]*/,	0x814f/*^*/,
	0x8151/*_*/,	0x814d/*`*/
    };
    static uint16_t as7b_7e[]={
	0x816f/*{*/,	0x8162/*|*/,	0x8170/*}*/,	0x8160/*~*/
    };
    static uint16_t wk[]={
	0x8142/**/,	0x8175/**/,	0x8176/**/,	0x8141/**/,	/*0*/
	0x8145/**/,	0x82f0/**/,	0x829f/**/,	0x82a1/**/,	/*1*/
	0x82a3/**/,	0x82a5/**/,	0x82a7/**/,	0x82e1/**/,	/*2*/
	0x82e3/**/,	0x82e5/**/,	0x82c1/**/,	0x815b/**/,	/*3*/
	0x82a0/**/,	0x82a2/**/,	0x82a4/**/,	0x82a6/**/,	/*4*/
	0x82a8/**/,	0x82a9/**/,	0x82ab/**/,	0x82ad/**/,	/*5*/
	0x82af/**/,	0x82b1/**/,	0x82b3/**/,	0x82b5/**/,	/*6*/
	0x82b7/**/,	0x82b9/**/,	0x82bb/**/,	0x82bd/**/,	/*7*/
	0x82bf/**/,	0x82c2/**/,	0x82c4/**/,	0x82c6/**/,	/*8*/
	0x82c8/**/,	0x82c9/**/,	0x82ca/**/,	0x82cb/**/,	/*9*/
	0x82cc/**/,	0x82cd/**/,	0x82d0/**/,	0x82d3/**/,	/*10*/
	0x82d6/**/,	0x82d9/**/,	0x82dc/**/,	0x82dd/**/,	/*11*/
	0x82de/**/,	0x82df/**/,	0x82e0/**/,	0x82e2/**/,	/*12*/
	0x82e4/**/,	0x82e6/**/,	0x82e7/**/,	0x82e8/**/,	/*13*/
	0x82e9/**/,	0x82ea/**/,	0x82eb/**/,	0x82ed/**/,	/*14*/
	0x82f1/**/,	0x814a/**/,	0x814b/**/
    };
    static uint16_t wd[]={
	0/**/,	0/**/,	0/**/,	0/**/,	/*0*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*1*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*2*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*3*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*4*/
	0/**/,	0x82aa/**/,	0x82ac/**/,	0x82ae/**/,	/*5*/
	0x82b0/**/,	0x82b2/**/,	0x82b4/**/,	0x82b6/**/,	/*6*/
	0x82b8/**/,	0x82ba/**/,	0x82bc/**/,	0x82be/**/,	/*7*/
	0x82c0/**/,	0x82c3/**/,	0x82c5/**/,	0x82c7/**/,	/*8*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*9*/
	0/**/,	0x82ce/**/,	0x82d1/**/,	0x82d4/**/,	/*10*/
	0x82d7/**/,	0x82da/**/,	0/**/,	0/**/,	/*11*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*12*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*13*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*14*/
	0/**/,	0/**/,	0/**/
    };
    static uint16_t wp[]={
	0/**/,	0/**/,	0/**/,	0/**/,	/*0*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*1*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*2*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*3*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*4*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*5*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*6*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*7*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*8*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*9*/
	0/**/,	0x82cf/**/,	0x82d2/**/,	0x82d5/**/,
	0x82d8/**/,	0x82db/**/,	0/**/,	0/**/,	/*11*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*12*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*13*/
	0/**/,	0/**/,	0/**/,	0/**/,	/*14*/
	0/**/,	0/**/,	0/**/
    };
    static uint16_t *wdp[]={wd,wp};

    unsigned char *s=(unsigned char*)src,cc,nc;
    int len=1;
    uint16_t z,z2;

    if(*s < 0x80 && *(s+1)==0){
	switch(*s){
	case 0x20 ... 0x2f:
	    z = as20_2f[*s-0x20];
	    break;
	case 0x3a ... 0x40:
	    z = as3a_40[*s-0x3a];
	    break;
	case 0x5b ... 0x60:
	    z = as5b_60[*s-0x5b];
	    break;
	case 0x7b ... 0x7e:
	    z = as7b_7e[*s-0x7b];
	    break;
	default: /*0-9,A-Z,a-z*/
	    z = 0x824f + *s - 0x30;
	}
    }else{
	cc = *s+opt;
	nc = *(s+ssz)+opt;
	z = wk[cc-0xa1];
	if(syn && (nc==0xde || nc==0xdf) && (z2=wdp[nc-0xde][cc-0xa1])!=0){
	    z = z2;
	    ++len;
	}
    }
    *((unsigned char*)dst++) = (z>>8);
    *(unsigned char*)dst = (unsigned char)z;
    return len;
}

//sjissƬʸܤΥХȿ֤(̥ʸϣ֤)
int char_length_sj(char *s)
{
    unsigned char c = *(unsigned char*)s;
    return c==0 ? 0 : ((c<0x80 || (c>=0xa1 && c<=0xdf)) ? 1 : 2);
}

//sjisʸƬnʸư
char *ForwardSj(char *sj,int n)
{
    while(--n >= 0)
	sj += char_length_sj(sj);
    return sj;
}

//eucjpʸƬnʸư롣ХʸϹθƤʤ
char *ForwardEj(char *ej,int n)
{
    while(--n >= 0 && *ej!=0){
	if(*(++ej) < 0)
	    ++ej;
    }
    return ej;
}

//sjissnʸܤΥХȿ֤
int CharLengthSj(char *s,int n)
{
    return char_length_sj(ForwardSj(s,n));
}

//eucjpʸsjisȾʸ
void StrEjZen2SjHan(char *s,char *e)
{
    int m;
    char buf[5],*bp;
    while(*e != 0){
	m = EjZen2Han(bp=buf,e);
	while(--m >= 0)
	    s = Ej2Sj(s,&bp);
	e = ForwardEj(e,1);
    }
    *s = 0;
}

/*
  eucjpѥɤȾѥɤˤ
  ͡ȾѥɤǤʸ(1 or 2)
  dst˥̥ʸĤΤ,5Хɬס
*/
int EjZen2Han(char *dst,char *src)
{
    /*
      ѤҤ餬(''(0xa4a1)...''(0xa4f4))Ⱦѥ
      1 1
      2 Ⱦ
      3 ȾѤΥ
    */
    static uint16_t hira2hkana[]={
	'','','','','','','','','','','',1,'',1,'',1,'',1,'',1,
	'',1,'',1,'',1,'',1,'',1,'',1,'',1,'','',1,'',1,'',1,'',
	'','','','','',1,2,'',1,2,'',1,2,'',1,2,'',1,2,'','','',
	'','','','','','','','','','','','','','','','','',
	'','',3
    };

    union {
	uint8_t u1[4];
	uint16_t u2[2];
	uint32_t u4;
    } wc;
    int len=1,moji=1,idx;

    wc.u1[1] = *((uint8_t*)src++);
    if((wc.u1[1] & 0x80) == 0){
	//ascii
	*(dst++) = wc.u1[1];
	*dst = 0;
	return 1;
    }

    wc.u1[0] = *((uint8_t*)src++);
    switch(wc.u2[0]){
    case '': wc.u1[1]=' '; break;
    case '': wc.u1[1]='!'; break;
    case '': wc.u1[1]='"'; break;
    case '': wc.u1[1]='#'; break;
    case '': wc.u1[1]='$'; break;
    case '': wc.u1[1]='%'; break;
    case '': wc.u1[1]='&'; break;
    case '': wc.u1[1]='\''; break;
    case '': wc.u1[1]='('; break;
    case '': wc.u1[1]=')'; break;
    case '': wc.u1[1]='*'; break;
    case '': wc.u1[1]='+'; break;
    case '': wc.u1[1]=','; break;
    case '': wc.u1[1]='-'; break;
    case '': wc.u1[1]='.'; break;
    case '': wc.u1[1]='/'; break;
    case '': wc.u1[1]=':'; break;
    case '': wc.u1[1]=';'; break;
    case '': wc.u1[1]='<'; break;
    case '': wc.u1[1]='='; break;
    case '': wc.u1[1]='>'; break;
    case '': wc.u1[1]='?'; break;
    case '': wc.u1[1]='@'; break;
    case '': wc.u1[1]='['; break;
    case '': wc.u1[1]='\\'; break;
    case '': wc.u1[1]=']'; break;
    case '': wc.u1[1]='^'; break;
    case '': wc.u1[1]='_'; break;
    case '': wc.u1[1]='`'; break;
    case '': wc.u1[1]='{'; break;
    case '': wc.u1[1]='|'; break;
    case '': wc.u1[1]='}'; break;
    case '': wc.u1[1]='~'; break;

    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '': wc.u2[0]=''; ++len; break;
    case '' ... '':
	wc.u1[1]=(uint8_t)(wc.u2[0]-''+'0'); break;
    case '' ... '':
	++len;
	wc.u2[0] = hira2hkana[idx=wc.u2[0]-''];
        switch(wc.u2[0]){
	case 1:
	    wc.u2[0] = hira2hkana[idx-1];
	    wc.u2[1] = '';
	    len += 2;
	    ++moji;
	    break;
	case 2:
	    wc.u2[0] = hira2hkana[idx-2];
	    wc.u2[1] = '';
	    len += 2;
	    ++moji;
	    break;
	case 3:
	    wc.u2[0] = '';
	    wc.u2[1] = '';
	    len += 2;
	    ++moji;
	}
	break;
    default:
	fprintf(stderr,"%s:illegal code 0x%04x\n",__FUNCTION__,wc.u2[0]);
    }
    for(idx=0; idx<4; idx+=2){
	dst[idx] = wc.u1[idx+1];
	dst[idx+1] = wc.u1[idx];
    }
    dst[len] = 0;
    return moji;
}

/*
  sjis -->euc-jp
  http://homepage3.nifty.com/aokura/jscript/jcode.html򻲹ͤˤ
*/
char *Sj2Ej(char *ej,char **sj)
{
    unsigned char k1,k2;

    k1 = *((*sj)++);
    if(k1 < 0x80)
	*(ej++) = k1;
    else if(k1 >= 0xa0 && k1 <= 0xdf){
	*(ej++) = 0x8e;
	*(ej++) = k1;
    }else{
	k1 <<= 1;
	k2 = *((*sj)++);
	if(k2 < 0x9f){
	    if(k1 < 0x3f)
		k1 += 0x1f;
	    else
		k1 -= 0x61;
	    if (k2 > 0x7e)
		k2 -= 0x20;
	    else
		k2 -= 0x1f;
	}else{
	    if(k1 < 0x3f)
		k1 += 0x20;
	    else
		k1 -= 0x60;
	    k2 -= 0x7e;
	}
	*(ej++) = (k1|0x80);
	*(ej++) = (k2|0x80);
    }
    return ej;
}

/*
  euc-jp --> sjis
  sjμΰ֤֤
*/
char *Ej2Sj(char *sj,char **ej)
{
    unsigned char k1,k2;

    k1 = *(*ej)++;
    if(k1<0x80)		//ascii
	*(sj++) = k1;
    else if(k1==0x8e){	//Ⱦѥ
	*(sj++) = *(*ej)++;
    }else{
	k1 &= 0x7f;
	k2 = *(*ej)++ & 0x7f;
	if((k1-=0x21) & 0x01){
	    k1 >>= 1;
	    k1 += (k1<0x1f ? 0x81 : 0xc1);
	    k2 += 0x7e;
	}else{
	    k1 >>= 1;
	    k1 += (k1<0x1f ? 0x81 : 0xc1);
	    k2 += 0x1f;
	    if(k2 > 0x7e)
		++k2;
	}
	*(sj++) = k1;
	*(sj++) = k2;
    }
    return sj;
}

/*
  sjis <--> euc-jp
  dΥ̥ʸΰ֤֤
*/
char *ConvCode(char *dst,char *src,char* (*cnv)(char*,char**))
{
    while(*src != 0)
	dst = cnv(dst,&src);
    *dst = 0;
    return dst;
}

//////////////////////////////////////////////////////////////////////////

Array* wstr_add_nwcs(Array* s,const uint16_t *cs,int len)
{
    memcpy(ArExpand(s,len),cs,len*s->blocksize);
    return s;
}
Array* wstr_add_wc(Array* s,uint16_t c)
{
    return wstr_add_nwcs(s,&c,1);
}
Array* wstr_add_wcs(Array* s,const uint16_t* cs)
{
    return wstr_add_nwcs(s,cs,WcLen(cs));
}
Array* wstr_add_wstr(Array* s,const Array* p)
{
    return wstr_add_nwcs(s,p->adr,p->using);
}
Array *wstr_add_sj2ej_n(Array *ws,char **sjis,int len,int le)
{
    uint16_t e;
    while(--len>=0 && **sjis!=0){
	e = 0;
	Sj2Ej((char*)&e,sjis);
	if(le && (e < 0x100))
	    e=(e>>8|e<<8);
	wstr_add_wc(ws,e);
    }
    return ws;
}
Array *wstr_add_sj2ej(Array *s,char *sjis,int le)
{
    return wstr_add_sj2ej_n(s,&sjis,INT_MAX,le);
}

//asciiϥȥ륨ǥǵϿ
Array *wstr_add_zen2han_ej(Array *s,uint16_t *h)
{
    int m,n;
    uint16_t dst[3];

    for(; *h!=0; ++h){
	m = EjZen2Han((char*)dst,(char*)h);
	for(n=0; n<m; ++n){
	    if(dst[n]<0x100)
		dst[n] = Swap2(dst[n]);
	    wstr_add_wc(s,dst[n]);
	}
    }
    return s;
}
Array *wstr_hira2kata_ej(Array *s)
{
    uint16_t c,*p;
    for(p=s->adr; *p!=0; ++p){
	c = ((*p>>8)|(*p<<8));
	if(c>=0xa4a1 && c<=0xa4f4)
	    ++ *p; //0xa4xx --> 0xa5xx
    }
    return s;
}
