#define _GNU_SOURCE
#include <getopt.h>
#include <windows.h>
#include <stdio.h>
#include <imm.h>
#include <process.h>
#include <stdint.h>
#include <errno.h>
#include "cannaapi.h"
#include "libwime.h"
#include "ut.h"
#include "apisup.h"

enum {
    WM_SET_COMP_STR = WM_APP,
    WM_CANNA_PACKET,	/* minor=0 */
    WM_CANNA_PACKET_EX = WM_CANNA_PACKET+256, /* minor=1 */
    WM_CANNA_PACKET_END = WM_CANNA_PACKET_EX+256
};

HMODULE LibCn;
PROT_RD FuncRead;
PROT_WR FuncWrite;
HANDLE MsgCompEv;
struct GlobalData_t WimeData;
int Verbose = 1;
WMCANNAPROTO* WmCannaTab[2];
int CanFunMax[2];

#define WIME_VERSION "1.8.5"

HWND NewWin();
unsigned __stdcall recv_xim(void *h);
LRESULT CALLBACK wnd_proc(HWND wh,UINT msg,WPARAM wp,LPARAM lp);
int init_canna(int socket_num);
int canna_api(CannaHeader *ch,char *data);
int cmdline_opt(int ac,char *av[]);
void init_cb(void);

int main(int ac,char *av[])
{
    HWND h;
    MSG msg;
    HANDLE th;
    WNDCLASS wc;
    int socket_num;

    init_cb();
    socket_num = cmdline_opt(ac,av);
    setbuf(stdout,NULL);
    VERBOSE(DBGP("register window\n"));
    memset(&wc,0,sizeof(wc));
    wc.lpfnWndProc = wnd_proc;
    wc.lpszClassName = "ImeBridge";
    if(!RegisterClass(&wc)){
	DBGP("fail RegisterClass\n");
	return 1;
    }

    MsgCompEv = CreateEvent(NULL,FALSE,FALSE,NULL);
    h = NewWin();
    if(init_canna(socket_num) != 0)
	return 1;

    ((PROT_READSETTING)GetProcAddress(LibCn,"ImReadSetting"))(&WimeData);
    th = (HANDLE)_beginthreadex(NULL,0,recv_xim,h,0,NULL);
    while(GetMessage(&msg, NULL, 0, 0) >0) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }
    CloseHandle(th);
    VERBOSE(DBG("EXIT\n"));
    return 0;
}

bool AtInit(WMCANNAPROTO* tab[]);

//ime̤ν
bool paticular_ime(const char* ime)
{
    typedef bool (*init_func_t)(WMCANNAPROTO* tab[]);
    struct{
	char* name;
	init_func_t init;
    } tab[]={
	{"atok",AtInit},
	{NULL,NULL}
    };
    int n;
    
    for(n=0; tab[n].name!=NULL && strcmp(tab[n].name,ime)!=0; ++n)
	;
    return tab[n].name!=NULL && tab[n].init(WmCannaTab);
}

/*
  ʤΥѥåȤ
*/
unsigned __stdcall recv_xim(void *h)
{
    CannaHeader ch;
    int rsz,fd;
    UINT msg;
    PROT_SEL im_sel,im_disconn;

    ArNew(&ch.Data,1,NULL);
    InitClientData(h);
    im_sel = (PROT_SEL)GetProcAddress(LibCn,"ImSelect");
    im_disconn = (PROT_SEL)GetProcAddress(LibCn,"ImDisconnect");

    while((fd = im_sel()) > 0){
	rsz = FuncRead(&ch,CANNAHEADERSIZE);
	if(rsz == 0){ //
	    VERBOSE(DBG("disconnect fd %d\n",fd));
	    im_disconn();
	    CloseConnection(fd);
	    continue;
	}
	if(ch.Major > 0){
	    ch.Length = Swap2(ch.Length);
	    ArReserve(&ch.Data,ch.Length);
	    FuncRead(ch.Data.adr,ch.Length);
	}
	VERBOSE(DBG("canna packet:major=0x%x minor=0x%x len=%d\n",ch.Major,ch.Minor,ch.Length));
	msg = WM_CANNA_PACKET+ch.Minor*256+ch.Major;
	SendMessage(h,msg,(WPARAM)&ch,(LPARAM)fd);
	//WaitForSingleObject(MsgCompEv,INFINITE);
	VERBOSE(DBG("awake\n"));
    }
    ArDelete(&ch.Data);
    VERBOSE(DBG("EXIT\n"));
    return 0;
}

/*
  ʤΥåȤȤä̿so(ؤΥץ)ɤ
  errno֤
*/
int init_canna(int socket_num)
{
    LibCn = LoadLibrary("libwime.dll");
    if(LibCn==NULL){
	DBGP("LoadLibrary fail\n");
	return ENOENT; //ELIBACC;
    }
    FuncRead = (PROT_RD)GetProcAddress(LibCn,"ImRead");
    FuncWrite = (PROT_WR)GetProcAddress(LibCn,"ImWrite");
    return ((PROT_INIT)GetProcAddress(LibCn,"ImInit"))(socket_num);
}

/*
  imeѤΥߡɥ
 */
HWND NewWin()
{
    HWND h;

    h = CreateWindow("ImeBridge","",0,0,0,0,0,NULL,NULL,NULL,NULL);
    //ShowWindow(h, SW_SHOW);
    VERBOSE(DBG("window handle %p\n",h));

    HIMC imc = ImmCreateContext();
    ImmSetOpenStatus(imc,TRUE);
    ImmAssociateContext(h,imc);
    //ImmReleaseContext(h,imc);
    return h;
}

//ɥץΥХåؿơ֥
void init_cb(void)
{
    static WMCANNAPROTO wm_canna_tab0[]={
	wm_canna_init,		/*00*/		NULL,			/*01*/
	wm_canna_finalize,	/*02*/		wm_create_context,	/*03*/
	wm_dup_context,		/*04*/		wm_close_context,	/*05*/
	wm_get_dic_list,	/*06*/		wm_get_dir_list,	/*07*/
	wm_mount_dic,		/*08*/		wm_unmount_dic,		/*09*/
	wm_remount_dic,		/*0a*/		wm_mount_dic_list,	/*0b*/
	wm_query_dic,		/*0c*/		wm_define_word,		/*0d*/
	wm_delete_word,		/*0e*/		wm_begin_conv,		/*0f*/
	wm_end_conv,		/*10*/		wm_get_candi_list,	/*11*/
	wm_get_yomi,		/*12*/		wm_subst_yomi,		/*13*/
	wm_store_yomi,		/*14*/		wm_store_range,		/*15*/
	wm_get_last_yomi,	/*16*/		wm_flush_yomi,		/*17*/
	wm_remove_yomi,		/*18*/		wm_get_simple_kanji,	/*19*/
	wm_resize_pause,	/*1a*/		wm_get_hinshi,		/*1b*/
	wm_get_lex,		/*1c*/		wm_get_status,		/*1d*/
	wm_set_locale,		/*1e*/		wm_auto_conv,		/*1f*/
	wm_query_ext,		/*20*/		wm_set_app_name,	/*21*/
	wm_notice_group,	/*22*/		NULL,			/*23*/
	wm_kill_server		/*24*/
    };
    static WMCANNAPROTO wm_canna_tab1[]={
	NULL,			/*00*/		wm_get_server_info,	/*01*/
	wm_get_acl,		/*02*/		wm_create_dic,		/*03*/
	wm_delete_dic,		/*04*/		wm_rename_dic,		/*05*/
	wm_get_word_text_dic,	/*06*/		wm_list_dic,		/*07*/
	wm_sync,		/*08*/		wm_chmod_dic,		/*09*/
	wm_copy_dic,		/*0a*/

	//ɲ
	wm_wime_dialog,	wm_wime_list_context,wm_wime_send_char
    };

    CanFunMax[0] = sizeof(wm_canna_tab0)/sizeof(wm_canna_tab0[0]);
    CanFunMax[1] = sizeof(wm_canna_tab1)/sizeof(wm_canna_tab1[0]);

    WmCannaTab[0] = wm_canna_tab0;
    WmCannaTab[1] = wm_canna_tab1;

}

void dbg_wm_comp_msg(unsigned lp);
const char* dbg_wm_notify_msg(unsigned wp);

//ɥץ
LRESULT CALLBACK wnd_proc(HWND wh,UINT msg,WPARAM wp,LPARAM lp)
{
    LRESULT r;

    r=0;
    switch(msg){
    case WM_IME_COMPOSITION:
	//DBG("WM_IME_COMPOSITION:wp=0x%x lp=",(unsigned)wp); dbg_wm_comp_msg((unsigned)lp); printf("\n");
	//wm_ime_composition(wh,lp);
	break;
    case WM_IME_NOTIFY:
	//ImmNotifyIME()Ƥ
	//DBG("WM_IME_NOTIFY:wp=%s lp=0x%x\n",dbg_wm_notify_msg((unsigned)wp),(unsigned)lp);
	break;
    default:
	if(msg>=WM_CANNA_PACKET && msg<WM_CANNA_PACKET_END){
	    unsigned major,minor;
	    WMCANNAPROTO func = NULL;
	    minor = (msg-WM_CANNA_PACKET)/256;
	    major = msg-(WM_CANNA_PACKET+minor*256);
	    if(minor<2 && major<CanFunMax[minor])
		func = WmCannaTab[minor][major];
	    if(func != NULL)
		r = (LRESULT)func((CannaHeader*)wp,(int)lp);
	    else{
		DBG("*** ILLEGAL CANNA PROTOCOL:minor=0x%x major=0x%x\n",minor,major);
		r = (LRESULT)true;
	    }
	}else
	    r = DefWindowProc(wh,msg,wp,lp);
    }
    return r;
}

void usage(int exit_code)
{
    printf("wime [options]\n"
	   "  -s ime	specify ime\n"
	   "  -p num	socket number\n"
	   "  -v,-v-	verbose (on,off)\n\n"
	   "  --version	print version\n"
	   "  -h,--help	this message\n"
	);
    exit(exit_code);
}

void print_version(void)
{
    printf("%s\n",WIME_VERSION);
}

//åȤΥץֹ֤
int cmdline_opt(int ac,char *av[])
{
    struct option longopt[]={
	{"help",0,NULL,'h'},
	{"version",0,NULL,'v'<<8},
	{NULL,0,NULL,0}
    };
    int c,socket_num=0;
    
    while((c = getopt_long(ac,av,"hp:s:v::",longopt,NULL)) != -1){
	switch(c){
	case 'h':
	    usage(0);
	case 'p':
	    socket_num = atoi(optarg);
	    break;
	case 's':
	    if(!paticular_ime(optarg)){
		fprintf(stderr,"not available ime '%s'\n",optarg);
		exit(1);
	    }
	    break;
	case 'v':
	    if(optarg == NULL)
		Verbose = 1;
	    else if(strcmp(optarg,"-")==0)
		Verbose = 0;
	    else
		usage(1);
	    break;
	case 'v'<<8:
	    print_version();
	    exit(0);
	default:
	    usage(1);
	}
    }
    return socket_num;
}

/*
  ꤷåidtrue
*/
bool MsgLoop(UINT m,WPARAM wp)
{
    bool r=false;
    UINT m0;
    WPARAM w0;
    MSG msg;

    while(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
	m0 = msg.message;
	w0 = msg.wParam;
	if(GetMessage(&msg,NULL,0,0) > 0){
	    TranslateMessage(&msg);
	    DispatchMessage(&msg);
	    if(m0==m && w0==wp){
		r = true;
		break;
	    }
	}
    }
    return r;
}
